//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_tkr_cevt;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userinterface.*;

public class Test_Api_2_Tkr_Cevt extends UiccTestModel {
    
    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_tkr_cevt";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
    
    public Test_Api_2_Tkr_Cevt() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
        
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1,
                "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries
                "00" +   // V Maximum number of channels
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s)
                "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");
        
        
        /*********************************************************************/
        /** Testcase 1. Clear allowed events                                 */
        /*********************************************************************/
        //Trigger applet
        test.envelopeSmsPp("0B254008 81556677 887FF600 11291200" +
                "00041402 7000000F 0D080000 00200101" +
                "00000000 010000");
        
        
        /*********************************************************************/
        /** Testcase 2.Checking applet isn't triggered by an                 */
        /** ENVELOPE(EVENT_FORMATTED_SMS_PP_ENV) command                   */
        /*********************************************************************/
        //Trigger applet
        test.envelopeSmsPp("0B254008 81556677 887FF600 11291200" +
                "00041402 7000000F 0D080000 00200101" +
                "00000000 010000");
        
        
        
        /***********************************/
        /**         Check results          */
        /***********************************/
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                "02CCCC"));
        
        
        test.reset();
        test.terminalProfileSession("1719");
        // Delete Applet
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);
        
        return getOverallResult();
    }
}
