//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gcst;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;

public class Test_Api_2_Ueh_Gcst extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_gcst";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
   
    private USimAPITestCardService test;
    APDUResponse response;
      
          
    public Test_Api_2_Ueh_Gcst() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        APDUResponse data = null;
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");

        // Install package
        test.loadPackage(CAP_FILE_PATH);
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "800A" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level         
                "00" +   // V Max. number of timers  
                "10" +   // V Maximum text length for a menu entry
                "01" +   // V Maximum number of menu entries
                "01" +   // V Id of menu entry 1     
                "01" +   // V Position of menu entry 1
                "01" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s)          
                "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");

        // Trigger Applet1
        response = test.envelopeSmsPp("06058011 2233448B 25400881 55667788" +
                                      "7FF60011 29120000 04140270 00000F0D" +
                                      "08000000 20010100 00000001 0001");
        // Fetch Open Channel proctive command
        test.fetch("1C");
        test.terminalResponse("81030140 01820282 81030100 38028100" +
                              "35040100 00003902 0080");
        // Testcase 1. Channel status TLV is not present                            
         test.unrecognizedEnvelope();
        
        // Testcase 2. Channel status TLV with the identifier is not present                            
        test.envelopeEventDownloadChannelStatus("38028100");
         
        // Testcase 3. Channel status TLV with a length equal to 0                           
        test.sendApdu("80C20000 0B010982 028381FF 01013800");
         
        // Testcase 4. Channel status TLV with a length equal to 1        
        test.sendApdu("80C20000 0C010A82 028381FF 01013801" +
                      "81");
       
        // Testcase 5. Get channel status value                              
        test.envelopeEventDownloadChannelStatus("38028100");
        
        // Testcase 6. Get channel status value with 2 TLV                   
        test.envelopeEventDownloadChannelStatus("38028100 38028101");

        // Testcase 7. Get channel status value with 2 TLV                  
        test.envelopeEventDownloadChannelStatus("38028100 38028201");  
        
        // Testcase 8. Channel status TLV is currently selected TLV          
        test.envelopeEventDownloadChannelStatus("38028100");

        // Testcase 8. Channel status TLV is currently selected TLV          
         test.envelopeEventDownloadChannelStatus("38028100");

        // Testcase 9. Channel status TLV is currently selected TLV          
        //Trigger applet
        test.envelopeEventDownloadChannelStatus("38028100");
        
        test.fetch("13");

        test.terminalResponse("81030121 80820282 81830100");

        /*********************************************************************/
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet1
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                     "09CCCCCC CCCCCCCC CCCC"));
    
        /*********************************************************************/
        /*********************************************************************/
        /** Restore  card                                                    */
        /*********************************************************************/

        test.reset();
        test.terminalProfileSession("1719");
                                          
        // Delete Applet1 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return getOverallResult();

    }
}   
