//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gsdl;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;

public class Test_Api_2_Ueh_Gsdl extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_gsdl";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
   
    private USimAPITestCardService test;
    APDUResponse response;
      
          
    public Test_Api_2_Ueh_Gsdl() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        APDUResponse data = null;
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("09030120");


        /*********************************************************************/
        /** FORMATTED SMS PP ENV Triggering                                  */
        /*********************************************************************/

        // Install package
        test.loadPackage(CAP_FILE_PATH);
        
        // Install Applet
        response = test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "00" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services

        test.reset();
        test.terminalProfileSession("1719");

        // Case 1 : Test with TP-OA length of 2
        response = test.envelopeSmsPp(  "8B4B4002 81557FF6 00112912 0000043D" +
                                        "02700000 380D0800 00002001 01000000" +
                                        "00010011 22334455 66778899 10111213" +
                                        "14151617 18191A1B 1C1D1E1F 20212223" +
                                        "24252627 28292A2B 2C2D2E2F 30");
        
         // Case 2 : Test with TP-OA length of 6
        response = test.envelopeSmsPp(  "8B4D4006 81556677 7FF60011 29120000" +
                                        "043D0270 0000380D 08000000 20010100" +
                                        "00000001 00112233 44556677 88991011" +
                                        "12131415 16171819 1A1B1C1D 1E1F2021" +
                                        "22232425 26272829 2A2B2C2D 2E2F30");
       
        // Case 3 : Test with TP-OA length of 12                           
        response = test.envelopeSmsPp(  "8B50400C 81334455 6677887F F6001129" +
                                        "12000004 3D027000 00380D08 00000020" +
                                        "01010000 00000100 11223344 55667788" +
                                        "99101112 13141516 1718191A 1B1C1D1E" +
                                        "1F202122 23242526 2728292A 2B2C2D2E" +
                                        "2F30");
         
       // Case 4 : Test with RC/CC/DS length of 0
        response = test.envelopeSmsPp(  "8B314002 81557FF6 00112912 00000423" +
                                        "02700000 1E0D0800 00002001 01000000" +
                                        "00010011 22334455 66778811 22334455" +
                                        "667788");

        // Case 5 : Test with RC/CC/DS length of 8
        response = test.envelopeSmsPp(  "06058011 2233448B 39400281 557FF600" +
                                        "11291200 00042B02 70000026 150A0200" +
                                        "11200101 00000000 010070C8 F096D326" +
                                        "74EE1011 12131415 16171819 1A1B1C1D" +
                                        "1E1F");
    
        // Case 6 : Test with PCNTR = 0
        response = test.envelopeSmsPp(  "8B344008 81556677 887FF600 11291200" +
                                        "00042302 7000001E 0D080000 00200101" +
                                        "00000000 02001011 12131415 16171819" +
                                        "1A1B1C1D 1E1F");

        // Case 7 : Test with PCNTR = 7 
        response = test.envelopeSmsPp(  "8B2E4008 81556677 887FF600 11291200" +
                                        "00041D02 70000018 0D0C0011 11200101" +
                                        "146DF2FF 4EE31703 89020069 887F6584");
        
         // Case 8 : Test with Secured Data Length = 00
        response = test.envelopeSmsPp(  "8B244008 81556677 887FF600 11291200" +
                                        "00041302 7000000E 0D080000 00200101" +
                                        "00000000 0100");

        // Case 9 : Test with Secured Data Length = 0x33
        response = test.envelopeSmsPp(  "8B59400C 81334455 6677887F F6001129" +
                                        "12000004 46027000 00410D08 00000020" +
                                        "01010000 00000100 01020304 05060708" +
                                        "090A0B0C 0D0E0F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F20 21222324 25262728" +
                                        "292A2B2C 2D2E2F30 313233");

        // Case 10 : Test with Secured Data Length = 0x6C (UDL = 0x7F)
        response = test.envelopeSmsPp(  "8B819240 0C813344 55667788 7FF60011" +
                                        "29120000 047F0270 00007A0D 08000000" +
                                        "20010100 00000001 00010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C");

        // Case 11 : Test with Secured Data Length = 0x6D (UDL = 0x80)
        response = test.envelopeSmsPp(  "8B819340 0C813344 55667788 7FF60011" +
                                        "29120000 04800270 00007B0D 08000000" +
                                        "20010100 00000001 00010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D");
        
        // Case 12 : Test with Secured Data Length = maximum length for one envelope : 0x79 (UDL = 0x8C)
        response = test.envelopeSmsPp(  "8B819F40 0C813344 55667788 7FF60011" +
                                        "29120000 048C0270 0000870D 08000000" +
                                        "20010100 00000001 00010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "08090A0B 0C0D0E0F 10010203 04050607" +
                                        "0809");
        
        // Case 13 : Verify it is the first TPDU TLV: Send a SMS PP with 2 TPDU TLV and inside two different secured data lengths: 5 and 10
        response = test.envelopeSmsPp(  "8B294008 81556677 887FF600 11291200" +
                                        "00041802 70000013 0D080000 00200101" +
                                        "00000000 01000102 0304058B 2E400881" +
                                        "55667788 7FF60011 29120000 041D0270" +
                                        "0000180D 08000000 28818500 00000001" +
                                        "00010203 04050607 08090A");

        // case 14 : Test with secured data length = 0x7F (2 concatenated envelopes are needed)
        response = test.envelopeSmsPp(  "8B819D40 08815566 77887FF6 00112912" +
                                        "0000048C 07000300 02017000 008D0D08" +
                                        "00000020 01010000 00000100 01020304" +
                                        "05060708 090A0B0C 0D0E0F10 11121314" +
                                        "15161718 191A1B1C 1D1E1F20 21222324" +
                                        "25262728 292A2B2C 2D2E2F30 31323334" +
                                        "35363738 393A3B3C 3D3E3F40 41424344" +
                                        "45464748 494A4B4C 4D4E4F50 51525354" +
                                        "55565758 595A5B5C 5D5E5F60 61626364" +
                                        "65666768 696A6B6C 6D6E6F70 71727374");   

        response = test.envelopeSmsPp(  "8B224008 81556677 887FF600 11291200" +
                                        "00041105 00030002 02757677 78797A7B" +
                                        "7C7D7E7F");

        // case 15 : Test with secured data length = 0x80 (2 concatenated envelopes are needed)
        response = test.envelopeSmsPp(  "8B819D40 08815566 77887FF6 00112912" +
                                        "0000048C 07000300 02017000 008E0D08" +
                                        "00000020 01010000 00000100 01020304" +
                                        "05060708 090A0B0C 0D0E0F10 11121314" +
                                        "15161718 191A1B1C 1D1E1F20 21222324" +
                                        "25262728 292A2B2C 2D2E2F30 31323334" +
                                        "35363738 393A3B3C 3D3E3F40 41424344" +
                                        "45464748 494A4B4C 4D4E4F50 51525354" +
                                        "55565758 595A5B5C 5D5E5F60 61626364" +
                                        "65666768 696A6B6C 6D6E6F70 71727374");

        response = test.envelopeSmsPp(  "8B234008 81556677 887FF600 11291200" +
                                        "00041205 00030002 02757677 78797A7B" +
                                        "7C7D7E7F 80");

        // case 16 : Test with secured data length = maximum length for 2 concatenated envelopes : 0xFA 
        response = test.envelopeSmsPp(  "8B819D40 08815566 77887FF6 00112912" +
                                        "0000048C 07000300 02017000 01080D08" +
                                        "00000020 01010000 00000100 01020304" +
                                        "05060708 090A0B0C 0D0E0F10 11121314" +
                                        "15161718 191A1B1C 1D1E1F20 21222324" +
                                        "25262728 292A2B2C 2D2E2F30 31323334" +
                                        "35363738 393A3B3C 3D3E3F40 41424344" +
                                        "45464748 494A4B4C 4D4E4F50 51525354" +
                                        "55565758 595A5B5C 5D5E5F60 61626364" +
                                        "65666768 696A6B6C 6D6E6F70 71727374");

        response = test.envelopeSmsPp(  "8B819D40 08815566 77887FF6 00112912" +
                                        "0000048C 05000300 02027576 7778797A" +
                                        "7B7C7D7E 7F808182 83848586 8788898A" +
                                        "8B8C8D8E 8F909192 93949596 9798999A" +
                                        "9B9C9D9E 9FA0A1A2 A3A4A5A6 A7A8A9AA" +
                                        "ABACADAE AFB0B1B2 B3B4B5B6 B7B8B9BA" +
                                        "BBBCBDBE BFC0C1C2 C3C4C5C6 C7C8C9CA" +
                                        "CBCCCDCE CFD0D1D2 D3D4D5D6 D7D8D9DA" +
                                        "DBDCDDDE DFE0E1E2 E3E4E5E6 E7E8E9EA" +
                                        "EBECEDEE EFF0F1F2 F3F4F5F6 F7F8F9FA");

        // case 17 : Test with FORMATTED_SMS_PP_ENV Verify after call of the method the current TLV is the TPDU TLV:
        // findTLV device identities, getSecuredDataLength and then getValueByte to verify that the current TLV is the TPDU TLV
        response = test.envelopeSmsPp(  "8B294008 81556677 887FF600 11291200" +
                                        "00041802 70000013 0D080000 00200101" +
                                        "00000000 01001011 121314"); 

        /*********************************************************************/
        /** FORMATTED SMS PP UPD Triggering                                  */
        /*********************************************************************/
       //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");      
        // Case 18 : Test with TP-OA length of 2
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" + // Data
                                        "12000004 3D027000 00380D08 00000020" +
                                        "01010000 00000100 11223344 55667788" +
                                        "99101112 13141516 1718191A 1B1C1D1E" +
                                        "1F202122 23242526 2728292A 2B2C2D2E" +
                                        "2F30FFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
          
        // Case 19 : Test with TP-OA length of 6
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 06815566 777FF600" +
                                        "11291200 00043D02 70000038 0D080000" +
                                        "00200101 00000000 01001122 33445566" +
                                        "77889910 11121314 15161718 191A1B1C" +
                                        "1D1E1F20 21222324 25262728 292A2B2C" +
                                        "2D2E2F30 FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
 
        // Case 20 : Test with TP-OA length of 12                           
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0C813344 55667788" +
                                        "7FF60011 29120000 043D0270 0000380D" +
                                        "08000000 20010100 00000001 00112233" +
                                        "44556677 88991011 12131415 16171819" +
                                        "1A1B1C1D 1E1F2021 22232425 26272829" +
                                        "2A2B2C2D 2E2F30FF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        // Case 21 : Test with RC/CC/DS length of 0
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 23027000 001E0D08 00000020" +
                                        "01010000 00000100 11223344 55667788" +
                                        "11223344 55667788 FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
 
        // Case 22 : Test with RC/CC/DS length of 8
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 2B027000 0026150A 02001120" +
                                        "01010000 00000100 70C8F096 D32674EE" +
                                        "10111213 14151617 18191A1B 1C1D1E1F" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

        // Case 23 : Test with PCNTR = 0
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 23027000 001E0D08 00000020" +
                                        "01010000 00000100 10111213 14151617" +
                                        "18191A1B 1C1D1E1F FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
     
        // Case 24 : Test with PCNTR = 7 
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 08815566 77887FF6" +
                                        "00112912 0000041D 02700000 180D0C00" +
                                        "11112001 01146DF2 FF4EE317 03890200" +
                                        "69887F65 84FFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
 
        // Case 25 : Test with Secured Data Length = 00
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 13027000 000E0D08 00000020" +
                                        "01010000 00000100 FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

        // Case 26 : Test with Secured Data Length = 0x33
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 46027000 00410D08 00000020" +
                                        "01010000 00000100 01020304 05060708" +
                                        "090A0B0C 0D0E0F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F20 21222324 25262728" +
                                        "292A2B2C 2D2E2F30 313233FF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
         
        // Case 27 : Test with Secured Data Length = 0x6C (UDL = 0x7F)
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 7F027000 007A0D08 00000020" +
                                        "01010000 00000100 01020304 05060708" +
                                        "090A0B0C 0D0E0F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
 
        // Case 28 : Test with Secured Data Length = 0x6D (UDL = 0x80)
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 80027000 007B0D08 00000020" +
                                        "01010000 00000100 01020304 05060708" +
                                        "090A0B0C 0D0E0F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1DFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

        // Case 29 : Test with Secured Data Length = maximum length for one envelope : 0x79 (UDL = 0x8C)
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 8C027000 00870D08 00000020" +
                                        "01010000 00000100 01020304 05060708" +
                                        "090A0B0C 0D0E0F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "191A1B1C 1D1E1F10 11121314 15161718" +
                                        "19FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
         
        // Case 30 : Verify it is the first TPDU TLV: Send a SMS PP with 2 TPDU TLV and inside two different secured data lengths: 5 and 10
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 08815566 77887FF6" +
                                        "00112912 00000418 02700000 130D0800" +
                                        "00002001 01000000 00010001 02030405" +
                                        "40088155 6677887F F6001129 12000004" +
                                        "1D027000 00180D08 00000028 81850000" +
                                        "00000100 01020304 05060708 090AFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
 
        // case 31 : Test with secured data length = 0x7F (2 concatenated envelopes are needed)
        // 1st Update record  
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 8C070003 00020170 00008D0D" +
                                        "08000000 20010100 00000001 00010203" +
                                        "04050607 08090A0B 0C0D0E0F 10111213" +
                                        "14151617 18191A1B 1C1D1E1F 20212223" +
                                        "24252627 28292A2B 2C2D2E2F 30313233" +
                                        "34353637 38393A3B 3C3D3E3F 40414243" +
                                        "44454647 48494A4B 4C4D4E4F 50515253" +
                                        "54555657 58595A5B 5C5D5E5F 60616263" +
                                        "64656667 68696A6B 6C6D6E6F 70717273" +
                                        "74FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");        

        // 2nd Update record  
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 11050003 00020275 76777879" +
                                        "7A7B7C7D 7E7FFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
   
        // case 32 : Test with secured data length = 0x80 (2 concatenated envelopes are needed)
        // 1st Update record  
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 8C070003 00020170 00008E0D" +
                                        "08000000 20010100 00000001 00010203" +
                                        "04050607 08090A0B 0C0D0E0F 10111213" +
                                        "14151617 18191A1B 1C1D1E1F 20212223" +
                                        "24252627 28292A2B 2C2D2E2F 30313233" +
                                        "34353637 38393A3B 3C3D3E3F 40414243" +
                                        "44454647 48494A4B 4C4D4E4F 50515253" +
                                        "54555657 58595A5B 5C5D5E5F 60616263" +
                                        "64656667 68696A6B 6C6D6E6F 70717273" +
                                        "74FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");    

        // 2nd Update record  
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 12050003 00020275 76777879" +
                                        "7A7B7C7D 7E7F80FF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

        // case 33 : Test with secured data length = maximum length for 2 concatenated envelopes : 0xFA 
        // 1st Update record  
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 8C070003 00020170 0001080D" +
                                        "08000000 20010100 00000001 00010203" +
                                        "04050607 08090A0B 0C0D0E0F 10111213" +
                                        "14151617 18191A1B 1C1D1E1F 20212223" +
                                        "24252627 28292A2B 2C2D2E2F 30313233" +
                                        "34353637 38393A3B 3C3D3E3F 40414243" +
                                        "44454647 48494A4B 4C4D4E4F 50515253" +
                                        "54555657 58595A5B 5C5D5E5F 60616263" +
                                        "64656667 68696A6B 6C6D6E6F 70717273" +
                                        "74FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
 
        // 2nd Update record  
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 0281557F F6001129" +
                                        "12000004 8C050003 00020275 76777879" +
                                        "7A7B7C7D 7E7F8081 82838485 86878889" +
                                        "8A8B8C8D 8E8F9091 92939495 96979899" +
                                        "9A9B9C9D 9E9FA0A1 A2A3A4A5 A6A7A8A9" +
                                        "AAABACAD AEAFB0B1 B2B3B4B5 B6B7B8B9" +
                                        "BABBBCBD BEBFC0C1 C2C3C4C5 C6C7C8C9" +
                                        "CACBCCCD CECFD0D1 D2D3D4D5 D6D7D8D9" +
                                        "DADBDCDD DEDFE0E1 E2E3E4E5 E6E7E8E9" +
                                        "EAEBECED EEEFF0F1 F2F3F4F5 F6F7F8F9" +
                                        "FAFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
       
        // case 34 : Test with FORMATTED_SMS_PP_UPD Verify after call of the method the current TLV is the TPDU TLV:
        // findTLV device identities, getSecuredDataLength and then getValueByte to verify that the current TLV is the TPDU TLV
        response = test.updateRecord(   "01", "04", 
                                        "03058011 22334440 08815566 77887FF6" +
                                        "00112912 00000418 02700000 130D0800" +
                                        "00002001 01000000 00010001 02030405" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

        /*********************************************************************/
        /** FORMATTED SMS CB Triggering                                           */
        /*********************************************************************/
        // Case 35 : Test with RC/CC/DS length of 0
        response = test.envelopeCellBroadcast(  "0C580000 1080F611 001E0D08 00000020" +
                                                "01010000 00000100 11223344 55667788" +
                                                "11223344 55667788 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 0000");

        // Case 36 : Test with RC/CC/DS length of 8
        response = test.envelopeCellBroadcast(  "0C580000 1080F611 0026150A 00001120" +
                                                "01010000 00000100 B737577A C22A601A" +
                                                "11223344 55667788 11223344 55667788" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 0000");
 
        // Case 37 : Test with PCNTR = 0
        response = test.envelopeCellBroadcast(  "0C580000 1080F611 001E0D08 00000020" +
                                                "01010000 00000100 10111213 14151617" +
                                                "18191A1B 1C1D1E1F 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 0000");

        // Case 38 : Test with PCNTR = 7 
        response = test.envelopeCellBroadcast(  "0C580000 1080F611 00180D0C 00111120" +
                                                "0101146D F2FF4EE3 17038902 0069887F" +
                                                "65840000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 0000");
       
        // Case 39 : Test with Secured Data Length = 00
        response = test.envelopeCellBroadcast(  "0C580000 1080F611 000E0D08 00000020" +
                                                "01010000 00000100 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 0000");
        
        // Case 40 : Test with Secured Data Length = 0x33       
        response = test.envelopeCellBroadcast(  "0C580000 1080F611 00410D08 00000020" +
                                                "01010000 00000100 01020304 05060708" +
                                                "090A0B0C 0D0E0F10 11121314 15161718" +
                                                "191A1B1C 1D1E1F20 21222324 25262728" +
                                                "292A2B2C 2D2E2F30 31323300 00000000" +
                                                "00000000 00000000 0000");
        
        // Case 41 : Test with Secured Data Length = maximum secured data length: 0x42
        response = test.envelopeCellBroadcast(  "0C580000 1080F611 00500D08 00000020" +
                                                "01010000 00000100 01020304 05060708" +
                                                "090A0B0C 0D0E0F10 01020304 05060708" +
                                                "090A0B0C 0D0E0F10 01020304 05060708" +
                                                "090A0B0C 0D0E0F10 01020304 05060708" +
                                                "090A0B0C 0D0E0F10 0102");       
         
        // Case 42 : Verify after call of the method the current TLV is the Cell Broadcast
        // Page TLV:findTLV device identities, getSecuredDataLength and then getValueByte 
        // to verify that the current TLV is the Cell Broadcast Page TLV   
        response = test.envelopeCellBroadcast(  "0C580000 1080F611 00130D08 00000020" +
                                                "01010000 00000100 10111213 14000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 0000");

        // CASE 43: try to apply the method getSecuredDataLength on an Unformatted SMS-CB envelope
        response = test.envelopeCellBroadcast(  "0C580000 10000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 00000000 00000000" +
                                                "00000000 00000000 0000");
         
        //Case 44: try to send an Unformatted SMS PP enveloppe
        response = test.envelopeSmsPp(  "06058011 2233448B 16100881 55667788" +
                                        "7FF60011 29120000 04051011 121314");
      
        /*********************************************************************/
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet1
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                    "2CCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                    "CCCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                    "CCCCCCCC CCCCCCCC CCCCCCCC CC"));
    
        test.reset();
        test.terminalProfileSession("1719");
        /*********************************************************************/
        /*********************************************************************/
        /** Restore  card                                                    */
        /*********************************************************************/
                                          
        // Delete Applet1 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return getOverallResult();

    }
}   
