//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gsml;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;

public class Test_Api_2_Ueh_Gsml extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_gsml";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
   
    private USimAPITestCardService test;
    APDUResponse response;
      
          
    public Test_Api_2_Ueh_Gsml() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        APDUResponse data = null;
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("09030120");


        /*********************************************************************/
        /** FORMATTED SMS PP ENV Triggering                                  */
        /*********************************************************************/

        // Install package
        test.loadPackage(CAP_FILE_PATH);
        
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "00" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services

        test.reset();
        test.terminalProfileSession("1719");
        
        // Case 1 : Test with TP-OA length of 2
        test.envelopeSmsPp( "8B4B4002 81557FF6 00112912 0000043D" +
                            "02700000 380D0800 00002001 01000000" +
                            "00010011 22334455 66778899 10111213" +
                            "14151617 18191A1B 1C1D1E1F 20212223" +
                            "24252627 28292A2B 2C2D2E2F 30");
         
        // Case 2 : Test with TP-OA length of 12                           
        test.envelopeSmsPp( "8B50400C 81334455 6677887F F6001129" +
                            "12000004 3D027000 00380D08 00000020" +
                            "01010000 00000100 11223344 55667788" +
                            "99101112 13141516 1718191A 1B1C1D1E" +
                            "1F202122 23242526 2728292A 2B2C2D2E" +
                            "2F30");
         
        // Case 3 : Test with PCNTR = 0
        test.envelopeSmsPp( "8B344008 81556677 887FF600 11291200" +
                            "00042302 7000001E 0D080000 00200101" +
                            "00000000 01001011 12131415 16171819" +
                            "1A1B1C1D 1E1F");
 
        // Case 4 : Test with PCNTR = 7 
        test.envelopeSmsPp( "8B2E4008 81556677 887FF600 11291200" +
                            "00041D02 70000018 0D0C0011 11200101" +
                            "146DF2FF 4EE31703 89020069 887F6584");
 
        // Case 5 : Test with RC/CC/DS length of 8
        test.envelopeSmsPp( "8B394002 81557FF6 00112912 0000042B" +
                            "02700000 26150A02 00112001 01000000" +
                            "00010070 C8F096D3 2674EE10 11121314" +
                            "15161718 191A1B1C 1D1E1F");
          
        // Case 6 : Test with Secured Data Length = 00
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 0100");
        
 
        // Case 7 : Test with Secured Data Length = maximum length for one envelope : 0x79 (UDL = 0x8C)
        test.envelopeSmsPp( "8B819F40 0C813344 55667788 7FF60011" +
                            "29120000 048C0270 0000870D 08000000" +
                            "20010100 00000001 00010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "0809");
  
        // Case 8 : Verify it is the first TPDU TLV: Send a SMS PP with 2 TPDU TLV with two different user data lengths:
        // 0x18 and 0x23 (with PCNTR = 0, no RC/CC/DS)
        test.envelopeSmsPp( "8B294008 81556677 887FF600 11291200" +
                            "00041802 70000013 0D080000 00200101" +
                            "00000000 01000102 0304058B 34400881" +
                            "55667788 7FF60011 29120000 04230270" +
                            "00001E0D 08000000 28818500 00000001" +
                            "00010203 04050607 08090A0B 0C0D0E0F" +
                            "01");
 
        // case 9 : Send envelope SMS-PP Formatted.FindTLV() with TAG_DEVICE_IDENTITIES. getUserDataLength() and then getValueByte() with 
        // offset 0
        test.envelopeSmsPp( "8B294008 81556677 887FF600 11291200" +
                            "00041802 70000013 0D080000 00200101" +
                            "00000000 01001011 121314"); 
 
        // case 10 : Test with secured data length = maximum length for 2 concatenated envelopes : 0xFA 
        test.envelopeSmsPp( "8B819D40 08815566 77887FF6 00112912" +
                            "0000048C 07000300 02017000 01080D08" +
                            "00000020 01010000 00000100 01020304" +
                            "05060708 090A0B0C 0D0E0F10 11121314" +
                            "15161718 191A1B1C 1D1E1F20 21222324" +
                            "25262728 292A2B2C 2D2E2F30 31323334" +
                            "35363738 393A3B3C 3D3E3F40 41424344" +
                            "45464748 494A4B4C 4D4E4F50 51525354" +
                            "55565758 595A5B5C 5D5E5F60 61626364" +
                            "65666768 696A6B6C 6D6E6F70 71727374");
 
        test.envelopeSmsPp( "8B819D40 08815566 77887FF6 00112912" +
                            "0000048C 05000300 02027576 7778797A" +
                            "7B7C7D7E 7F808182 83848586 8788898A" +
                            "8B8C8D8E 8F909192 93949596 9798999A" +
                            "9B9C9D9E 9FA0A1A2 A3A4A5A6 A7A8A9AA" +
                            "ABACADAE AFB0B1B2 B3B4B5B6 B7B8B9BA" +
                            "BBBCBDBE BFC0C1C2 C3C4C5C6 C7C8C9CA" +
                            "CBCCCDCE CFD0D1D2 D3D4D5D6 D7D8D9DA" +
                            "DBDCDDDE DFE0E1E2 E3E4E5E6 E7E8E9EA" +
                            "EBECEDEE EFF0F1F2 F3F4F5F6 F7F8F9FA");
        
        /*********************************************************************/
        /** FORMATTED SMS PP UPD Triggering                                  */
        /*********************************************************************/
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");      
        // Case 11 : Test with TP-OA length of 2
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" + // Data
                            "12000004 3D027000 00380D08 00000020" +
                            "01010000 00000100 11223344 55667788" +
                            "99101112 13141516 1718191A 1B1C1D1E" +
                            "1F202122 23242526 2728292A 2B2C2D2E" +
                            "2F30FFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
          
        // Case 12 : Test with TP-OA length of 12                           
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0C813344 55667788" +
                            "7FF60011 29120000 043D0270 0000380D" +
                            "08000000 20010100 00000001 00112233" +
                            "44556677 88991011 12131415 16171819" +
                            "1A1B1C1D 1E1F2021 22232425 26272829" +
                            "2A2B2C2D 2E2F30FF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

        // Case 13 : Test with PCNTR = 0
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 23027000 001E0D08 00000020" +
                            "01010000 00000100 10111213 14151617" +
                            "18191A1B 1C1D1E1F FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        // Case 14 : Test with PCNTR = 7 
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 08815566 77887FF6" +
                            "00112912 0000041D 02700000 180D0C00" +
                            "11112001 01146DF2 FF4EE317 03890200" +
                            "69887F65 84FFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        // Case 15 : Test with RC/CC/DS length of 8
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 2B027000 0026150A 02001120" +
                            "01010000 00000100 70C8F096 D32674EE" +
                            "10111213 14151617 18191A1B 1C1D1E1F" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
   
        // Case 16 : Test with Secured Data Length = 00
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 13027000 000E0D08 00000020" +
                            "01010000 00000100 FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
  
         // Case 17 : Test with Secured Data Length = maximum length for one envelope : 0x79 (UDL = 0x8C)
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 8C027000 00870D08 00000020" +
                            "01010000 00000100 01020304 05060708" +
                            "090A0B0C 0D0E0F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "191A1B1C 1D1E1F10 11121314 15161718" +
                            "19FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
           
        // Case 18 : Verify it is the first TPDU TLV: Send a SMS PP with 2 TPDU TLV and inside two different secured data lengths: 5 and 10
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 08815566 77887FF6" +
                            "00112912 00000418 02700000 130D0800" +
                            "00002001 01000000 00010001 02030405" +
                            "40088155 6677887F F6001129 12000004" +
                            "23027000 001E0D08 00000028 81850000" +
                            "00000100 01020304 05060708 090A0B0C" +
                            "0D0E0F10 FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
   
        // case 19 : Test with FORMATTED_SMS_PP_ENV Verify after call of the method the current TLV is the TPDU TLV:
        // findTLV device identities, getSecuredDataLength and then getValueByte to verify that the current TLV is the TPDU TLV
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 08815566 77887FF6" +
                            "00112912 00000418 02700000 130D0800" +
                            "00002001 01000000 00010001 02030405" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
   
        // case 20 : Test with secured data length = maximum length for 2 concatenated envelopes : 0xFA 
        // 1st Update record  
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 8C070003 00020170 0001080D" +
                            "08000000 20010100 00000001 00010203" +
                            "04050607 08090A0B 0C0D0E0F 10111213" +
                            "14151617 18191A1B 1C1D1E1F 20212223" +
                            "24252627 28292A2B 2C2D2E2F 30313233" +
                            "34353637 38393A3B 3C3D3E3F 40414243" +
                            "44454647 48494A4B 4C4D4E4F 50515253" +
                            "54555657 58595A5B 5C5D5E5F 60616263" +
                            "64656667 68696A6B 6C6D6E6F 70717273" +
                            "74FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
   
        // 2nd Update record  
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 8C050003 00020275 76777879" +
                            "7A7B7C7D 7E7F8081 82838485 86878889" +
                            "8A8B8C8D 8E8F9091 92939495 96979899" +
                            "9A9B9C9D 9E9FA0A1 A2A3A4A5 A6A7A8A9" +
                            "AAABACAD AEAFB0B1 B2B3B4B5 B6B7B8B9" +
                            "BABBBCBD BEBFC0C1 C2C3C4C5 C6C7C8C9" +
                            "CACBCCCD CECFD0D1 D2D3D4D5 D6D7D8D9" +
                            "DADBDCDD DEDFE0E1 E2E3E4E5 E6E7E8E9" +
                            "EAEBECED EEEFF0F1 F2F3F4F5 F6F7F8F9" +
                            "FAFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
       
        /*********************************************************************/
        /** FORMATTED SMS CB Triggering                                      */
        /*********************************************************************/
        // Case 21 : Test with PCNTR = 0
        test.envelopeCellBroadcast( "0C580000 1080F611 001E0D08 00000020" +
                                    "01010000 00000100 10111213 14151617" +
                                    "18191A1B 1C1D1E1F 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
        
        // Case 22 : Test with PCNTR = 7 
        test.envelopeCellBroadcast( "0C580000 1080F611 00180D0C 00111120" +
                                    "0101146D F2FF4EE3 17038902 0069887F" +
                                    "65840000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
         
         // Case 23 : Test with RC/CC/DS length of 8
        test.envelopeCellBroadcast( "0C580000 1080F611 0026150A 00001120" +
                                    "01010000 00000100 B737577A C22A601A" +
                                    "11223344 55667788 11223344 55667788" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
   
        // Case 24 : Test with Secured Data Length = 00
        test.envelopeCellBroadcast( "0C580000 1080F611 000E0D08 00000020" +
                                    "01010000 00000100 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
    
        // Case 25 : Test with Secured Data Length = maximum secured data length: 0x42
        test.envelopeCellBroadcast( "0C580000 1080F611 00500D08 00000020" +
                                    "01010000 00000100 01020304 05060708" +
                                    "090A0B0C 0D0E0F10 01020304 05060708" +
                                    "090A0B0C 0D0E0F10 01020304 05060708" +
                                    "090A0B0C 0D0E0F10 01020304 05060708" +
                                    "090A0B0C 0D0E0F10 0102");       
    
        // Case 26 : Verify it is the first Cell Broadcast Page TLV: Send a SMS CB with 2 
        // Cell Broadcast Page TLV with two different user data lengths: 0x18 and 0x23 (with PCNTR = 0, no RC/CC/DS)
        test.envelopeCellBroadcast( "0C580000 1080F611 00160D08 00000020" +
                                    "01010000 00000100 01020304 05060708" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000C58 00001080" +
                                    "F6110021 0D080000 00200101 00000000" +
                                    "01001011 12131415 16171819 1A1B1C1D" +
                                    "1E1F2021 22000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000");
   
        // Case 27 : Verify after call of the method the current TLV is the Cell Broadcast
        // Page TLV:findTLV device identities, getSecuredDataLength and then getValueByte 
        // to verify that the current TLV is the Cell Broadcast Page TLV   
        test.envelopeCellBroadcast( "0C580000 1080F611 00130D08 00000020" +
                                    "01010000 00000100 10111213 14000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");

        /*********************************************************************/
        /** UNFORMATTED SMS PP ENV Triggering                                */
        /*********************************************************************/

        // Case 28 : Test with TP-OA length of 2
        test.envelopeSmsPp( "8B4B0002 81557FF6 00112912 0000043D" +
                            "11223344 55667788 99101112 13141516" +
                            "1718191A 1B1C1D1E 1F202122 23242526" +
                            "2728292A 2B2C2D2E 2F303132 33343536" +
                            "3738393A 3B3C3D3E 3F404142 43");
           
        // Case 29 : Test with TP-OA length of 12                           
        test.envelopeSmsPp( "8B50000C 81334455 6677887F F6001129" +
                            "12000004 3D112233 44556677 88991011" +
                            "12131415 16171819 1A1B1C1D 1E1F2021" +
                            "22232425 26272829 2A2B2C2D 2E2F3031" +
                            "32333435 36373839 3A3B3C3D 3E3F4041" +
                            "4243");
           
        // Case 30 : Test with UserDataLength = 0x00
        test.envelopeSmsPp( "8B110008 81556677 887FF600 11291200" +
                            "000400");

   
        // Case 31 : Test with UserDataLength = 0x7F
        test.envelopeSmsPp( "8B819200 0C813344 55667788 7FF60011" +
                            "29120000 047F0102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C0D0E0F 10010203 04050607" +
                            "08090A0B 0C");
    
        // Case 32 : Test with UserDataLength = 0x80
        test.envelopeSmsPp( "8B819300 0C813344 55667788 7FF60011" +
                            "29120000 04800102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F10");

        // Case 33 : Test with UserDataLength = maximum length: 0x8C for a single SMS
        test.envelopeSmsPp( "8B819F00 0C813344 55667788 7FF60011" +
                            "29120000 048C0102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C0D0E 0F100102 03040506 0708090A" +
                            "0B0C");

        // Case 34 : Verify it is the first TPDU TLV: Send a SMS PP with 2 TPDU TLV with two different user data lengths: 0x18 and 0x23
        test.envelopeSmsPp( "8B290008 81556677 887FF600 11291200" +
                            "00041801 02030405 06070809 0A0B0C0D" +
                            "0E0F1011 12131415 1617188B 34400881" +
                            "55667788 7FF60011 29120000 04230102" +
                            "03040506 0708090A 0B0C0D0E 0F101112" +
                            "13141516 1718191A 1B1C1D1E 1F202122" +
                            "23");
   
        // case 35 : Test with FORMATTED_SMS_PP_ENV Verify after call of the method the current TLV is the TPDU TLV:
        // findTLV device identities, getShortMessageLength and then getValueByte to verify that the current TLV is the TPDU TLV
        test.envelopeSmsPp( "8B290008 81556677 887FF600 11291200" +
                            "00041802 70000013 0D080000 00200101" +
                            "00000000 02001011 121314"); 
     
        /*********************************************************************/
        /** UNFORMATTED SMS PP UPD Triggering                                */
        /*********************************************************************/
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");      
        // Case 36 : Test with TP-OA length of 2
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" + // Data
                            "12000004 3D112233 44556677 88991011" +
                            "12131415 16171819 1A1B1C1D 1E1F2021" +
                            "22232425 26272829 2A2B2C2D 2E2F3031" +
                            "32333435 36373839 3A3B3C3D 3C3E3F40" +
                            "4142FFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
          
         // Case 37 : Test with TP-OA length of 12                           
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0C813344 55667788" +
                            "7FF60011 29120000 043D1122 33445566" +
                            "77889910 11121314 15161718 191A1B1C" +
                            "1D1E1F20 21222324 25262728 292A2B2C" +
                            "2D2E2F30 31323334 35363738 393A3B3C" +
                            "3DFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
  
        // Case 38 : Test with UserDataLength = 0x00
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" +
                            "12000004 00FFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
   
         // Case 39 : Test with UserDataLength = 0x7F
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" +
                            "12000004 7F010203 04050607 08090A0B" +
                            "0C0D0E0F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
           
        // Case 40 : Test with UserDataLength = 0x80
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" +
                            "12000004 80010203 04050607 08090A0B" +
                            "0C0D0E0F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10FFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        // Case 41 : Verify it is the first TPDU TLV: Send a SMS PP with 2 TPDU TLV with two different user data lengths: 0x18 and 0x23
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 08815566 77887FF6" +
                            "00112912 00000418 01020304 05060708" +
                            "090A0B0C 0D0E0F10 11121314 15161718" +
                            "00088155 6677887F F6001129 12000004" +
                            "23010203 04050607 08090A0B 0C0D0E0F" +
                            "10111213 14151617 18191A1B 1C1D1E1F" +
                            "20212223 FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
  
         // Case 42 : Test with UserDataLength = maximum length: 0x8C for a single SMS
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 0281557F F6001129" +
                            "12000004 8C010203 04050607 08090A0B" +
                            "0C0D0E0F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1C1D1E1F 10111213 14151617 18191A1B" +
                            "1CFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
   
        // case 43: Send envelope SMS-PP Formatted.FindTLV() with TAG_DEVICE_IDENTITIES.
        //GetUserDataLength() and then getValueByte() with offset 0
        test.updateRecord(  "01", "04", 
                            "03058011 22334400 08815566 77887FF6" +
                            "00112912 00000418 01020304 05060708" +
                            "090A0B0C 0D0E0F10 11121314 15161718" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
  
        /*********************************************************************/
        /** UNFORMATTED SMS CB Triggering                                           */
        /*********************************************************************/
        // Case 44 : Test with UNFORMATTED_SMS_CB
        test.envelopeCellBroadcast( "0C580000 107FF611 10111213 14151617" +
                                    "18191A1B 1C1D1E1F 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
        
        // Case 45 : Verify it is the first Cell Broadcast Page TLV: Send a SMS CB with 2 Cell Broadcast
        // Page TLV with two different user data lengths: 0x58 and 0x23
        test.envelopeCellBroadcast( "0C580000 107FF611 001A0D08 00000010" +
                                    "01010000 00000107 10111213 14000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000C23 01020304" +
                                    "05060708 090A0B0C 0D0E0F10 11121314" +
                                    "15161718 191A1B1C 1D1E1F20 212223");
  
        // Case 46 : Send envelope SMS-CB Formatted.FindTLV() with TAG_DEVICE_IDENTITIES. 
        // GetShortMessageLength() and then getValueByte() with offset 0
        test.envelopeCellBroadcast( "0C580000 107FF611 000E0D08 00000010" +
                                    "01010000 00000100 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
    
        /*********************************************************************/
        /** Unrecognized Envelope Triggering                                    */
        /*********************************************************************/
        // Case 47 : Send an Unrecognized Envelope with neither TPDU TLV nor Cell Broadcast Page TLV, then call the method.
        test.unrecognizedEnvelope();
        
        // Case 48 : Send an Unrecognized Envelope with a bad TPDU TLV, then call the method.
        test.sendApdu(  "80C20000 0B010982 0283818B 03000102");
   
        // Case 49  : Send an Unrecognized Envelope with a bad Cell Broadcast Page TLV, then call the method.
        test.sendApdu(  "80C20000 0B010982 0283818C 03000102");
   

        /*********************************************************************/
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet1
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                    "2FCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                    "CCCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                    "CCCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC"));
    
        /*********************************************************************/
        /*********************************************************************/
        /** Restore  card                                                    */
        /*********************************************************************/
                                          
        test.reset();
        test.terminalProfileSession("1719");
        // Delete Applet1 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return getOverallResult();

    }
}   
