//-----------------------------------------------------------------------------
//Api_2_Ueh_Gsmo_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gsmo;
import uicc.usim.test.util.TestToolkitApplet;
import uicc.toolkit.*;
import uicc.toolkit.ToolkitException;
import uicc.usim.toolkit.*;

/**
* Test Area : uicc.usim.tookit.USATEnvelopeHandler.getShortMessageOffset()
*/
public class Api_2_Ueh_Gsmo_1  extends TestToolkitApplet implements uicc.usim.toolkit.ToolkitConstants
{
    
    // Number of tests
    byte testCaseNb = (byte) 0x00;
      
    /**
    * Constructor of the applet
    */
    public Api_2_Ueh_Gsmo_1 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Api_2_Ueh_Gsmo_1  thisApplet = new Api_2_Ueh_Gsmo_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        
        // Initialise the data of the test applet
        thisApplet.init();
        
        // Set Formatted SMS PP UPD as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
         
        // Set Formatted SMS PP ENV as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
          // Set Formatted SMS CB as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_CB);
        
          // Set Unformatted SMS CB as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
        
        // Set Unformatted SMS PP as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);
        
          // Set Unformatted SMS PP as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
        
        // Set Unrecognized Envelope as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
        
    }
    
    
    /**
    * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
          USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
        ProactiveHandler proHdlr = ProactiveHandlerSystem.getTheHandler() ;
        
        switch ( testCaseNb ) 
        {
            //=================================================================
            //=========        FORMATTED SMS PP ENV triggering        =========
            //=================================================================
            case (byte) 0 :
                // --------------------------------------------
                // Test Case 1 : getShortMessageOffset with various length of TP-OA:2
                testCaseNb = (byte) 1 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x11) 
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                    
            case (byte) 1 :
                // --------------------------------------------
                // Test Case 2 : getShortMessageOffset with various length of TP-OA:12
                testCaseNb = (byte) 2 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x16)  
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 2 :
                // --------------------------------------------
                // Test Case 3 : getShortMessageOffset with various length of RC/CC/DS:8
                testCaseNb = (byte) 3 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x11)  
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 3 :
                // --------------------------------------------
                // Test Case 4 : getShortMessageOffset when the SMS PP contains 2 TLV
                testCaseNb = (byte) 4 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x14) 
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 4 :
                // --------------------------------------------
                // Test Case 5 : getShortMessageOffset without secured data
                testCaseNb = (byte) 5 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x11)  
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 5 :
                // --------------------------------------------
                // Test Case 6 : findTLV device Identities (Formatted SMS PP envelope)
                testCaseNb = (byte) 6 ;
    
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageOffset() == 0x14)&&
                        (envHdlr.getValueByte((short)0)==0x40))
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 6 :
                // --------------------------------------------
                // Test Case 7 : Concatenated SMS with maximum secured data length (0xFA)
                testCaseNb = (byte) 7 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x14)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                       break;
            
    
            //=================================================================
            //=========        FORMATTED SMS PP UPD triggering        =========
            //=================================================================
            case (byte) 7 :
                // --------------------------------------------
                // Test Case 8 : getShortMessageOffset with various length of TP-OA:2
                testCaseNb = (byte) 8 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x11) 
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            
            case (byte) 8 :
                //             --------------------------------------------
                // Test Case 9 : Test with TP-OA length of 12 and RC/CC/DS length is 0
                testCaseNb = (byte) 9 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x16)   
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 9 :
                // --------------------------------------------
                // Test Case 10 : Test with RC/CC/DS length of 8 and TP-OA length is 2
                testCaseNb = (byte) 10 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x11)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 10 :
                // --------------------------------------------
                // Test Case 11 : getShortMessageOffset when the SMS UPD contains 2 TLV
                testCaseNb = (byte) 11 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x14)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 11 :
                //             --------------------------------------------
                // Test Case 12 : Test with TP-OA length of 2 and RC/CC/DS length is 0 without any secured data
                testCaseNb = (byte) 12 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x11)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
        
            case (byte) 12 :
                //             --------------------------------------------
                // Test Case 13 : findTLV device Identities (Formatted SMS UPD envelope)
                testCaseNb = (byte) 13 ;
    
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageOffset() == 0x11)&&
                        (envHdlr.getValueByte((short)0)==0x40))
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 13 :
                // --------------------------------------------
                // Test Case 14 : Concatenated SMS with maximum secured data length (0xFA)
                testCaseNb = (byte) 14 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x11)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            //=================================================================
            //=========          FORMATTED SMS CB triggering          =========
            //=================================================================
            case (byte) 14 :
                // --------------------------------------------
                // Test Case 15 : getShortMessageOffset with various length of RC/CC/DS:0
                testCaseNb = (byte) 15 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x06)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 15 :
                // --------------------------------------------
                // Test Case 16 : getShortMessageOffset with various length of RC/CC/DS:8
                testCaseNb = (byte) 16 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x06)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 16 :
                // --------------------------------------------
                // Test Case 17 : getShortMessageOffset without secured data
                testCaseNb = (byte) 17 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x06)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 17 :
                // --------------------------------------------
                // Test Case 18 : findTLV device Identities (Formatted SMS CB envelope)
                testCaseNb = (byte) 18 ;
    
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageOffset() == 0x06)&&
                        (envHdlr.getValueByte((short)0)==0x00))
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
    
            //=================================================================
            //=========             UNFORMATTED triggering            =========
            //=================================================================
            case (byte) 18 :
                // --------------------------------------------
                // Test Case 19 : try to apply the getShortMessageOffset method on an Unformatted SMS PP envelope TP-OA length= 2
                testCaseNb = (byte) 19 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x0E)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 19 :
                // --------------------------------------------
                // Test Case 20 : try to apply the getShortMessageOffset method on an Unformatted SMS PP envelope TP-OA length = 12
                testCaseNb = (byte) 20 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x13)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 20 :
                //         --------------------------------------------
                // Test Case 21 : getShortMessageOffset when the Unformatted SMS PP contains 2 TLV
                testCaseNb = (byte) 21 ;
                
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x11)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 21 :
                //             --------------------------------------------
                // Test Case 22 : findTLV device Identities (Unformatted SMS PP envelope)
                testCaseNb = (byte) 22 ;
    
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageOffset() == 0x11)&&
                        (envHdlr.getValueByte((short)0)==0x00))
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 22 :
                // --------------------------------------------
                // Test Case 23 : try to apply the getShortMessageOffset method on an Unformatted SMS PP envelope
                testCaseNb = (byte) 23 ;
    
                bRes = false ;
                try {
                    if (((envHdlr.getShortMessageOffset() == (short)0x000E) || (envHdlr.getShortMessageOffset() == (short)0x000F)) &&
                            (envHdlr.getValueShort(envHdlr.getShortMessageOffset()) == (short)0x0102))
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 23 :
                // --------------------------------------------
                // Test Case 24 : try to apply the getShortMessageOffset method on an Unformatted SMS UPD envelope
                testCaseNb = (byte) 24 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x0E)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 24 :
                // --------------------------------------------
                // Test Case 25 : try to apply the getShortMessageOffset method on an Unformatted SMS UPD envelope
                testCaseNb = (byte) 25 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x13)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 25 :
                //         --------------------------------------------
                // Test Case 26 : findTLV device Identities (Unformatted SMS UPD envelope)
                testCaseNb = (byte) 26 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x11)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 26 :
                //             --------------------------------------------
                // Test Case 27 : findTLV device Identities (Formatted SMS UPD envelope)
                testCaseNb = (byte) 27 ;
    
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageOffset() == 0x11)&&
                        (envHdlr.getValueByte((short)0)==0x00))
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 27 :
                // --------------------------------------------
                // Test Case 28 : try to apply the getShortMessageOffset method on an Unformatted SMS UPD envelope
                testCaseNb = (byte) 28 ;
    
                bRes = false ;
                try {
                    if (((envHdlr.getShortMessageOffset() == (short)0x000E) || (envHdlr.getShortMessageOffset() == (short)0x000F)) &&
                            (envHdlr.getValueShort(envHdlr.getShortMessageOffset()) == (short)0x0102))
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
              /*********************************************************************/
              /** UNFORMATTED SMS CB Triggering                                    */
              /*********************************************************************/
    
            case (byte) 28 :
                // --------------------------------------------
                // Test Case 29 : try to apply the getShortMessageOffset method on an Unformatted SMS CB envelope
                testCaseNb = (byte) 29 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageOffset() == 0x06)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 29 :
                // --------------------------------------------
                // Test Case 30 : findTLV device Identities (Unformatted SMS CB envelope)
                testCaseNb = (byte) 30 ;
    
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageOffset() == 0x06)&&
                        (envHdlr.getValueByte((short)0)==0x00))
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 30 :
                // --------------------------------------------
                // Test Case 31 : try to apply the getShortMessageOffset method on an Unrecognized envelope
                testCaseNb = (byte) 31 ;
    
                bRes = false ;
                try {
                    short returnvalue = envHdlr.getShortMessageOffset();
                }
                catch (ToolkitException e)    {
                    if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT) 
                        bRes = true ;
                    else
                        bRes = false ;
                }
                catch (Exception e)    {    
                        bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
        }
    }
}
