//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ues_gthd;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ues_Gthd extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ues_gthd";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ues_Gthd() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        initialiseResults();
            
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries
                "00" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");
          
        /**********************************************************************/
        /** Testcase 1 test the methode getTheHandler() twice                 */
        /**********************************************************************/      
        
        test.sendApdu(  "80C20000 30D12E82 02838106 05801122" +
                        "33448B21 40028155 7FF60011 29120000" +
                        "04130270 00000E0D 08000000 20010100" +
                        "00000001 00");
        
        /**********************************************************************/
        /** Testcase 2 verify that the methode getTheHandler return           */
        /** EnvelopeHandler reference                                         */
        /**********************************************************************/      
        
        test.sendApdu(  "80C20000 30D12E82 02838106 05801122" +
                        "33448B21 40028155 7FF60011 29120000" +
                        "04130270 00000E0D 08000000 20010100" +
                        "00000001 00");
        
        /**********************************************************************/
        /** Testcase 3 verify that the methode getTheHandler()                */
        /** does not return null                                              */
        /**********************************************************************/      
        
        test.sendApdu(  "80C20000 30D12E82 02838106 05801122" +
                        "33448B21 40028155 7FF60011 29120000" +
                        "04130270 00000E0D 08000000 20010100" +
                        "00000001 00");
        
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                    "03CCCCCC"));
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
      
        return getOverallResult();
    }
}   
