/**
 * ETSI TS 102 268: UICC API testing
 * USAT Framework part 5
 * Test source for Other parts transferred to framework from API
 * A handler is a temporary JCRE Entry Point object
 */
//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_api_hepo;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;

public class Test_Ufw_Api_Hepo extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_api_hepo";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 50010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 50010102";
    USimAPITestCardService test;
    APDUResponse response;

    public Test_Ufw_Api_Hepo() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }

    public boolean run() {

        initialiseResults();

        // start test
        test.reset();
        test.terminalProfileSession("0101");
        
        // install package and applet
        test.loadPackage(CAP_FILE_PATH);
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1,
                          "8008" + // TLV UICC Toolkit application specific parameters
                            "01" + // V Priority Level
                            "00" + // V Max. number of timers
                            "0A" + // V Maximum text length for a menu entry
                            "00" + // V Maximum number of menu entries
                            "00" + // V Maximum number of channels 
                            "00" + // LV Minimum Security Level field
                            "00" + // LV TAR Value(s) 
                            "00"); // V Maximum number of services 

        // test script
        test.reset();
        test.terminalProfileSession("0101");

        // test case 1 to 8: trigger applet1
        response = test.unrecognizedEnvelope();
        addResult(response.checkSw("9000"));
        

        // check results
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 + "02CCCC"));

        // delete applet and package
        test.reset();
        test.terminalProfileSession("0101");
        test.deleteApplet(APPLET_AID_1);
        test.deletePackage(CAP_FILE_PATH);

        return getOverallResult();
    }
}

