//-----------------------------------------------------------------------------
//    Ufw_Apt_Efse_1.java
//-----------------------------------------------------------------------------

package uicc.usim.test.usatframework.ufw_apt_efse;

import uicc.toolkit.*;
import uicc.usim.test.util.*;
import javacard.framework.*;


/**
 *
 * Applet is triggered on Install (Install)
 *
 *
 */
public class Ufw_Apt_Efse_1 extends TestToolkitApplet {
    private static byte[] baMyBuffer = {
            (byte) 0x02, (byte) 0x70, (byte) 0x00, (byte) 0x00, (byte) 0x7C
        };
    private static final byte TAG_SMS_TPDU = (byte) 0x8B;
    private byte testCaseNb = (byte) 1;
    private boolean bRes;

    /**
    * Constructor of the applet
    */
    public Ufw_Apt_Efse_1() {
    }

    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) {
        // Create a new applet instance.
        Ufw_Apt_Efse_1 thisApplet = new Ufw_Apt_Efse_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short) (bOffset + 1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();

        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        thisApplet.obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
    }

    public void processToolkit(short event) {
        // Get the system instance of the envelope Handler
        EnvelopeHandler envHdlr = EnvelopeHandlerSystem.getTheHandler();

        if (event == EVENT_FORMATTED_SMS_PP_ENV) {
            switch (testCaseNb) {
            case 1:

                // Test Case 1: The applet is triggered by the single message
                bRes = true;
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 2;

                break;

            case 2:

                // Test Case 1: The applet is triggered by the concatenated message
                try {
                    if (envHdlr.findAndCompareValue(TAG_SMS_TPDU, (byte) 1,
                                (short) 0x11, baMyBuffer, (short) 0,
                                (short) baMyBuffer.length) == 0) {
                        bRes = true;
                    } else {
                        bRes = false;
                    }

                    // The applet is deregistered to the event
                    obReg.clearEvent(EVENT_FORMATTED_SMS_PP_ENV);
                } catch (Exception e) {
                    bRes = false;
                }

                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 3;

                // Test Case 2: 1/2-The applet shall not be triggered
                reportTestOutcome(testCaseNb, true);
                testCaseNb = (byte) 4;

                break;

            case 4:

                // Test Case 2: 1/2-The applet shall not be triggered           	
                // if the applet is triggered the test fails
                bRes = false;
                testCaseNb = (byte) 3;
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 4;

                break;

            case 5:

                // Test Case 2: 3-The applet is triggered after the registration to the event by the single message
                bRes = true;
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 6;

                break;

            case 6:

                // Test Case 2: 4-The applet is triggered by the concatenated message
                if (envHdlr.findAndCompareValue(TAG_SMS_TPDU, (byte) 1,
                            (short) 0x11, baMyBuffer, (short) 0,
                            (short) baMyBuffer.length) == 0) {
                    bRes = true;
                } else {
                    bRes = false;
                }

                reportTestOutcome(testCaseNb, bRes);

                break;
            }
        }

        if ((event == EVENT_UNRECOGNIZED_ENVELOPE) && (testCaseNb == 4)) {
            // Test Case 2: The applet is registered to the event
            try {
                obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
                bRes = true;
            } catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);
            testCaseNb = (byte) 5;
        }
    }
}
