//-----------------------------------------------------------------------------
//Test_Ufw_Tin_Acdo.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_tin_acdo;

import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

/**
 * Test Area : uicc.usim.test.usatframework.ufw_tin_acdo
 *
 * @version 0.0.1 - 15 sept. 2005
 * @author 3GPP T3 SWG API
 */
public class Test_Ufw_Tin_Acdo extends UiccTestModel {


    static final String             CAP_FILE_PATH          = "uicc/usim/test/usatframework/ufw_tin_acdo";

    private final String            CLASS_AID_1            = "A0000000 871005FF FFFFFF89 50010001";
    private final String            APPLET_AID_1           = "A0000000 871005FF FFFFFF89 50010102";
    
    /** */
    private USimAPITestCardService test;
    /** contains the response of the processed apdu*/
    private APDUResponse response;

    private static String           ADF_1_AID           = "A0000000090005FFFFFFFF89E0000002";
    /** */
    public Test_Ufw_Tin_Acdo() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    /**
     * @todo terminal profile
     */
    public boolean run() {
            
            initialiseResults();
         
            // test script
            test.reset();
            test.terminalProfile("0301");
            test.enablePIN(UiccCardManagementService.APPLICATION_PIN_1,"31313131 FFFFFFFF");
            
            // Install package
            test.loadPackage(CAP_FILE_PATH);
            
            // Test case 1 : The access granted to an application shall be independent
            //               from the USAT Framework/Terminal interface.
            
            // 1.1 Install Applet1 with access domain set to PIN2
            test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                                "8008" + // TLV UICC Toolkit application specific parameters
                                "01" +   // V Priority Level
                                "00" +   // V Max. number of timers
                                "00" +   // V Maximum text length for a menu entry
                                "00" +   // V Maximum number of menu entries                              
                                "00" +   // V Maximum number of channels 
                                "00" +   // LV Minimum Security Level field
                                "00" +   // LV TAR Value(s) 
                                "00" +   // V Maximum number of services
                                "811B" + // TLV UICC Access application specific parameters
                                "00" +   // LV UICC File System AID field
                                "0402010000" + // LV Access Domain for UICC file system = PIN Application 2
                                "00" +   // LV Access Domain DAP field
                                "10A0000000090005FFFFFFFF89E0000002" + // LV ADF1 File System AID field
                                "0100" + // LV Access Domain for ADF1 file system = Full Access
                                "00"    // LV Access Domain DAP field
                                ); 
            
            test.selectApplication(ADF_1_AID);
            // terminal profile
            test.terminalProfile("03010000 0102");
            // 1.2 Block the PIN1 by sending unsuccessfull verify PIN command
            response = test.verifyPIN(UiccCardManagementService.APPLICATION_PIN_1,"31313132 FFFFFFFF");
            response = test.verifyPIN(UiccCardManagementService.APPLICATION_PIN_1,"31313132 FFFFFFFF");
            response = test.verifyPIN(UiccCardManagementService.APPLICATION_PIN_1,"31313132 FFFFFFFF");
            response = test.verifyPIN(UiccCardManagementService.APPLICATION_PIN_1,"31313132 FFFFFFFF");
            addResult(response.checkSw("6983"));
            
            // 1.3 Unrecognized envelope is send to the applet
            // The applet try to access the EF_CIAC using increase() method.
            response = test.sendApdu("80C20000 09010782 028381DA 0101");
            addResult(response.checkSw("9000"));

            // Unblock the PIN_APPLICATION_1
            response = test.unblockPIN(UiccCardManagementService.APPLICATION_PIN_1,"33333333 33333333","31313131 FFFFFFFF");
            addResult(response.checkSw("9000"));

            //get test result
            response = test.selectApplication(APPLET_AID_1);
            addResult(response.checkData("10"+APPLET_AID_1+
                                         "01CC"));
            
            // 1.4 Delete the applet instance
            test.reset();
            test.terminalProfile("0301");
            test.deleteApplet(APPLET_AID_1);

            // Test case 2 : Access domain set to FF, no access
            
            // 2.1 Install Applet1 with access domain set to PIN2
            test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                                "8008" + // TLV UICC Toolkit application specific parameters
                                "01" +   // V Priority Level
                                "00" +   // V Max. number of timers
                                "00" +   // V Maximum text length for a menu entry
                                "00" +   // V Maximum number of menu entries                              
                                "00" +   // V Maximum number of channels 
                                "00" +   // LV Minimum Security Level field
                                "00" +   // LV TAR Value(s) 
                                "00" +   // V Maximum number of services
                                "8118" + // TLV UICC Access application specific parameters
                                "00" +   // LV UICC File System AID field
                                "01FF" + // LV Access Domain for UICC file system = No access
                                "00" +   // LV Access Domain DAP field
                                "10A0000000090005FFFFFFFF89E0000002" + // LV ADF1 File System AID field
                                "0100" + // LV Access Domain for ADF1 file system = Full access
                                "00"    // LV Access Domain DAP field
                                ); 
            
            test.selectApplication(ADF_1_AID);
            // terminal profile
            test.terminalProfile("03010000 0102");

            // 2.2 Unrecognized envelope is send to the applet
            // The applet try to access the EF_CIAC using increase() method.
            response = test.sendApdu("80C20000 09010782 028381DA 0102");
            addResult(response.checkSw("9000"));

            //get test result
            response = test.selectApplication(APPLET_AID_1);
            addResult(response.checkData("10"+APPLET_AID_1+
                                         "02CCCC"));

            // 2.3 Delete the applet instance
            test.reset();
            test.terminalProfile("0301");
            test.deleteApplet(APPLET_AID_1);

            // Test case 3 : Access domain set to 00, full access
            
            // 3.1 Install Applet1 with access domain set to PIN2
            test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                                "8008" + // TLV UICC Toolkit application specific parameters
                                "01" +   // V Priority Level
                                "00" +   // V Max. number of timers
                                "00" +   // V Maximum text length for a menu entry
                                "00" +   // V Maximum number of menu entries                              
                                "00" +   // V Maximum number of channels 
                                "00" +   // LV Minimum Security Level field
                                "00" +   // LV TAR Value(s) 
                                "00" +   // V Maximum number of services
                                "8118" + // TLV UICC Access application specific parameters
                                "00" +   // LV UICC File System AID field
                                "0100" + // LV Access Domain for UICC file system = No access
                                "00" +   // LV Access Domain DAP field
                                "10A0000000090005FFFFFFFF89E0000002" + // LV ADF1 File System AID field
                                "0100" + // LV Access Domain for ADF1 file system = Full access
                                "00"    // LV Access Domain DAP field
                                ); 
            
            test.selectApplication(ADF_1_AID);
            // terminal profile
            test.terminalProfile("03010000 0102");

            // 3.2 et 3.3 Unrecognized envelope is send to the applet
            // The applet try to access the EF_CIAC using increase() method.
            response = test.sendApdu("80C20000 09010782 028381DA 0103");
            addResult(response.checkSw("9000"));

            //get test result
            response = test.selectApplication(APPLET_AID_1);
            addResult(response.checkData("10"+APPLET_AID_1+
                                         "03CCCCCC"));

            // 3.4 Delete the applet instance and package
            test.reset();
            test.terminalProfile("0301");
            test.deleteApplet(APPLET_AID_1);
            test.deletePackage(CAP_FILE_PATH);
            test.disablePIN(UiccCardManagementService.APPLICATION_PIN_1,"31313131 FFFFFFFF");

            return getOverallResult();
    }
}
